#
# Conditional build:
%bcond_without	doc	# Sphinx documentation
%bcond_without	tests	# unit tests
%bcond_without	python2 # CPython 2.x module
%bcond_without	python3 # CPython 3.x module

%define		module	persistent
Summary:	Automatic persistence for Python objects
Summary(pl.UTF-8):	Automatyczne trwałe obiekty w Pythonie
Name:		python-%{module}
# keep 4.x here for python2 support
Version:	4.9.3
Release:	1
License:	ZPL v2.1
Group:		Libraries/Python
#Source0Download: https://pypi.org/simple/persistent/
Source0:	https://files.pythonhosted.org/packages/source/p/persistent/%{module}-%{version}.tar.gz
# Source0-md5:	8bc80f8c548f45631c85efb775a85dc1
Patch0:		missing-header.patch
URL:		https://www.zope.dev/
%if %{with python2}
BuildRequires:	python-cffi
BuildRequires:	python-devel >= 1:2.7
BuildRequires:	python-setuptools
%if %{with tests}
BuildRequires:	python-manuel
BuildRequires:	python-zope.interface
BuildRequires:	python-zope.testrunner
%endif
%endif
%if %{with python3}
BuildRequires:	python3-cffi
BuildRequires:	python3-devel >= 1:3.5
BuildRequires:	python3-setuptools
%if %{with tests}
BuildRequires:	python3-manuel
BuildRequires:	python3-zope.interface
BuildRequires:	python3-zope.testrunner
%endif
%endif
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.714
%if %{with doc}
BuildRequires:	python3-repoze.sphinx.autointerface
BuildRequires:	sphinx-pdg-3
%endif
Requires:	python-modules >= 1:2.7
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
This package contains a generic persistence implementation for Python.
It forms the core protocol for making objects interact "transparently"
with a database such as the ZODB.

%description -l pl.UTF-8
Ten pakiet zawiera ogólną implementację trwałych danych dla Pythona.
Tworzy główny protokół, pozwalający obiektom w sposób przezroczysty
współpracować z bazą danych taką jak ZODB.

%package devel
Summary:	Header files for C extensions using persisteny module
Summary(pl.UTF-8):	Pliki nagłówkowe dla rozszerzeń w C korzystających z modułu persistent
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	python-devel >= 1:2.7

%description devel
Header files for C extensions using persisteny module.

%description devel -l pl.UTF-8
Pliki nagłówkowe dla rozszerzeń w C korzystających z modułu
persistent.

%package -n python3-%{module}
Summary:	Automatic persistence for Python objects
Summary(pl.UTF-8):	Automatyczne trwałe obiekty w Pythonie
Group:		Libraries/Python
Requires:	python3-modules >= 1:3.5

%description -n python3-%{module}
This package contains a generic persistence implementation for Python.
It forms the core protocol for making objects interact "transparently"
with a database such as the ZODB.

%description -n python3-%{module} -l pl.UTF-8
Ten pakiet zawiera ogólną implementację trwałych danych dla Pythona.
Tworzy główny protokół, pozwalający obiektom w sposób przezroczysty
współpracować z bazą danych taką jak ZODB.

%package -n python3-%{module}-devel
Summary:	Header files for C extensions using persisteny module
Summary(pl.UTF-8):	Pliki nagłówkowe dla rozszerzeń w C korzystających z modułu persistent
Group:		Development/Libraries
Requires:	python3-%{module} = %{version}-%{release}
Requires:	python3-devel >= 1:3.5

%description -n python3-%{module}-devel
Header files for C extensions using persisteny module.

%description -n python3-%{module}-devel -l pl.UTF-8
Pliki nagłówkowe dla rozszerzeń w C korzystających z modułu
persistent.

%package apidocs
Summary:	API documentation for Python persistent module
Summary(pl.UTF-8):	Dokumentacja API modułu Pythona persistent
Group:		Documentation

%description apidocs
API documentation for Python persistent module.

%description apidocs -l pl.UTF-8
Dokumentacja API modułu Pythona persistent.

%prep
%setup -q -n %{module}-%{version}
%patch0 -p1

%build
%if %{with python2}
%py_build

%if %{with tests}
PYTHONPATH=$(echo $(pwd)/build-2/lib.*) \
zope-testrunner-2 --test-path=src -v
%endif
%endif

%if %{with python3}
%py3_build

%if %{with tests}
PYTHONPATH=$(echo $(pwd)/build-3/lib.*) \
zope-testrunner-3 --test-path=src -v
%endif
%endif

%if %{with doc}
PYTHONPATH=$(pwd) \
%{__make} -C docs html \
	SPHINXBUILD=sphinx-build-3
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%py_install

%py_postclean
%{__rm} $RPM_BUILD_ROOT%{py_sitedir}/persistent/*.[ch]
%{__rm} -r $RPM_BUILD_ROOT%{py_sitedir}/persistent/tests
%endif

%if %{with python3}
%py3_install

%{__rm} $RPM_BUILD_ROOT%{py3_sitedir}/persistent/*.[ch]
%{__rm} -r $RPM_BUILD_ROOT%{py3_sitedir}/persistent/tests
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%files
%defattr(644,root,root,755)
%doc CHANGES.rst COPYRIGHT.txt LICENSE.txt README.rst
%dir %{py_sitedir}/persistent
%{py_sitedir}/persistent/*.py[co]
%attr(755,root,root) %{py_sitedir}/persistent/*.so
%{py_sitedir}/persistent-%{version}-py*.egg-info

%files devel
%defattr(644,root,root,755)
%{py_incdir}/persistent
%endif

%if %{with python3}
%files -n python3-%{module}
%defattr(644,root,root,755)
%doc CHANGES.rst COPYRIGHT.txt LICENSE.txt README.rst
%dir %{py3_sitedir}/persistent
%{py3_sitedir}/persistent/*.py
%attr(755,root,root) %{py3_sitedir}/persistent/*.so
%{py3_sitedir}/persistent/__pycache__
%{py3_sitedir}/persistent-%{version}-py*.egg-info

%files -n python3-%{module}-devel
%defattr(644,root,root,755)
%{py3_incdir}/persistent
%endif

%if %{with doc}
%files apidocs
%defattr(644,root,root,755)
%doc docs/_build/html/{_static,api,*.html,*.js}
%endif
%changelog
* Wed Sep 27 2023 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python-persistent.git;a=log;h=master

* Mon Sep 25 2023 Jakub Bogusz <qboosh@pld-linux.org> ef32a27
- updated to 4.9.3

* Tue Apr 26 2022 Jakub Bogusz <qboosh@pld-linux.org> 6b18ad0
- updated to 4.9.0
- separated -devel subpackages

* Wed Mar 30 2022 Jan Rękorajski <baggins@pld-linux.org> fe623e3
- rebuild with tests and docs

* Sat Mar 26 2022 Jan Rękorajski <baggins@pld-linux.org> 7468ac6
- rebuild with python 3.10

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> 14d6c25
- rebuild with python 3.10

* Sat Feb 26 2022 Jan Rękorajski <baggins@pld-linux.org> 588d6e5
- install missing header, rel 3

* Sat Feb 26 2022 Jan Rękorajski <baggins@pld-linux.org> 7c298bc
- restore headers, they are required for building BTrees module, rel 2

* Wed Feb 23 2022 Jakub Bogusz <qboosh@pld-linux.org> e8337ec
- updated to 4.7.0

* Sat Nov 20 2021 Jan Rękorajski <baggins@pld-linux.org> 56f830c
- rebuild with separate debuginfo build-ids

* Sat Mar 06 2021 Jan Palus <atler@pld-linux.org> 583156c
- up to 4.6.4

* Fri Feb 26 2021 Jan Rękorajski <baggins@pld-linux.org> d34b93b
- release 7 (by relup.sh)

* Mon Oct 28 2019 Jakub Bogusz <qboosh@pld-linux.org> 0dbf35f
- BR: python-setuptools

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> 68ebdbb
- rebuild with python 3.8
- release 6 (by relup.sh)

* Sun Jul 01 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> a8a4de9
- release 5 (by relup.sh)

* Thu Nov 16 2017 Mateusz Korniak <matkor@pld-linux.org> 1694403
- Replaced %{_includedir}/python* with %{py*_incdir}

* Mon Nov 13 2017 Mateusz Korniak <matkor@pld-linux.org> f3408e2
- Rel 3. Added source and header files from sitedirs.

* Mon Nov 13 2017 Mateusz Korniak <matkor@pld-linux.org> a2b435e
- Rel 2. Added header files from includedir to packages.

* Mon Nov 13 2017 Mateusz Korniak <matkor@pld-linux.org> dc7756b
- Initial 4.2.4.2. Rel. 1

